## sra-sdk 2.9.3+dfsg

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


#-------------------------------------------------------------------------------
# environment
#
TOP ?= $(CURDIR)
include $(TOP)/build/Makefile.shell


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	shared \
	tools \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

default: $(SUBDIRS)

test: all

$(SUBDIRS) test:
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# all
#
$(SUBDIRS_ALL):

#-------------------------------------------------------------------------------
# std
#
$(SUBDIRS_STD):

#-------------------------------------------------------------------------------
# install
#
install: 
	@ echo "Checking make status of tools..."
	@ $(MAKE) -s --no-print-directory TOP=$(CURDIR) std
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.install install

uninstall:    
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.install uninstall

.PHONY: install uninstall

#-------------------------------------------------------------------------------
# clean
#
clean: clean_deb clean_rpm clean_test

clean_test:
	@ $(MAKE) -s -C test clean

#-------------------------------------------------------------------------------
# runtests
#
runtests: runtests_test

runtests_test:
	@ $(MAKE) -s -C test runtests

#	@ $(MAKE) -s -C ngs runtests

#-------------------------------------------------------------------------------
# slowtests
#
slowtests: slowtests_test

slowtests_test:
	@ $(MAKE) -s -C test slowtests

#-------------------------------------------------------------------------------
# valgrind
#
valgrind: valgrind_test

valgrind_test:
	@ $(MAKE) -s -C test valgrind

#-------------------------------------------------------------------------------
# RPM
#
ifeq (mac,$(OS))
rpm:
	@ echo "Not making rpm on Mac"
clean_rpm:
else
rpm: std
	@ $(MAKE)       rpm -s TOP=$(CURDIR) -f build/Makefile.rpm
clean_rpm:
	@ $(MAKE) clean_rpm -s TOP=$(CURDIR) -f build/Makefile.rpm
endif

#-------------------------------------------------------------------------------
# DEB
#
ifeq (mac,$(OS))
deb: std
else
deb:
endif
	@ $(MAKE)       deb -s TOP=$(CURDIR) -f build/Makefile.deb
clean_deb:
	@ $(MAKE) clean_deb -s TOP=$(CURDIR) -f build/Makefile.deb

#-------------------------------------------------------------------------------
# pass-through targets
#
COMPILERS = GCC ICC VC++ CLANG
ARCHITECTURES = i386 x86_64 sparc32 sparc64
CONFIG = debug profile release
PUBLISH = scm pubtools
REPORTS = bindir targdir osdir config compilers architecture architectures
PASSTHRUS = \
	out \
	CC $(COMPILERS) \
	$(ARCHITECTURES) \
	$(CONFIG) $(PUBLISH) \
	purify purecov \
	local static dynamic

$(RHOSTS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env local
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env require-proxy-exec
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env rebuild-dirlinks config

$(PASSTHRUS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env rebuild-dirlinks config

$(REPORTS):
	@ $(MAKE) -s TOP=$(CURDIR) -f build/Makefile.env $@

.PHONY: $(PASSTHRUS) $(RHOSTS) $(REPORTS)


#-------------------------------------------------------------------------------
# configuration help
#
help configure:
	@ echo "Before initial build, run './configure --build-prefix=<out>' from"
	@ echo "the project root to set the output directory of your builds."
	@ echo
	@ echo "To select a compiler, run 'make <comp>' where"
	@ echo "comp = { "$(COMPILERS)" }."
	@ echo
	@ echo "For hosts that support cross-compilation ( only Macintosh today ),"
	@ echo "you can run 'make <arch>' where arch = { "$(ARCHITECTURES)" }."
	@ echo
	@ echo "To set a build configuration, run 'make <config>' where"
	@ echo "config = { "$(CONFIG)" }."
	@ echo
	@ echo "To select a remote build configuration, run 'make <rhost>' where"
	@ echo "rhost = { "$(RHOSTS)" }."
	@ echo

.PHONY: help configure

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =    \
	read-filter-redact \
	prefetch        \
	dump-test       \
	vdb-config      \
	vcf-loader      \
	align-info      \
	align-cache     \
	vdb-validate    \
	kar             \
	copycat         \
	vdb-copy        \
	qual-recalib-stat \
	sra-stat        \
	srapath         \
	sra-sort        \
	sra-pileup      \
	fuse            \
	fastq-loader    \
	kget            \
	vdb-dump        \

# under construction
#    ngs-pileup      \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#   time of slowtests in linux release mode
# real    4m 0.076s      user    4m22.256s      sys     0m10.707s     sra-sort
# real    5m21.151s      user    5m59.396s      sys     0m39.296s     fastdump
# real    6m55.921s      user    6m28.035s      sys     6m58.052s     sra-pileup
# real  184m21.347s      user   42m19.318s      sys   259m56.028s     fuse

=== tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: default

TOP ?= $(abspath ..)
MODULE = tools

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =             \
	util              \
	align-cache       \
	kar               \
	kqsh              \
	vdb-dump          \
	sra-dump          \
	sra-pileup        \
	bam-loader        \
	fastq-loader      \
	srapath           \
	sra-stat          \
	vdb-copy          \
	rd-filter-redact  \
	vdb-config        \
	align-info        \
	qual-recalib-stat \
	prefetch          \
	vdb-decrypt       \
	vdb-validate      \
	sra-sort          \
	cache-mgr         \
	vcf-loader        \
	copycat           \
	fasterq-dump      \
	sra-load          \
	ccextract         \
	pacbio-load       \
	fuse              \
	vdb-diff          \
	kget              \
	ngs-pileup        \
	vdb-sql           \
	cg-load           \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== test/dump-test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)

include $(TOP)/build/Makefile.env

runtests: check_fastq_dump_crash

check_fastq_dump_crash:
	$(BINDIR)/fastq-dump -Z -split-3 ERR034677 SRR125365 > /dev/null

=== test/fastq-loader/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

#TODO: transfer slowtests/big_loads (see CVS)

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fastq-loader

TEST_TOOLS = \
	wb-test-fastq \
	wb-test-fastq-parse \
	test-fastq-loader

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# FASTQ parsing test
#
FASTQ_PARSE_SRC = \
	wb-test-fastq-parse

FASTQ_PARSE_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_PARSE_SRC))

FASTQ_PARSE_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-vdb \

$(TEST_BINDIR)/wb-test-fastq-parse: $(FASTQ_PARSE_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_PARSE_LIB)

parse: wb-test-fastq-parse
	$(TEST_BINDIR)/wb-test-fastq-parse  2>&1


#-------------------------------------------------------------------------------
# white-box test
#
FASTQ_TEST_SRC = \
	wb-test-fastq

FASTQ_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_TEST_SRC))

FASTQ_TEST_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-wvdb \

$(TEST_BINDIR)/wb-test-fastq: $(FASTQ_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

wb: wb-test-fastq
	$(TEST_BINDIR)/wb-test-fastq  2>&1

#-------------------------------------------------------------------------------
# test-fastqtest-loader
#
FASTQTEST_LOADER_SRC = \
	test-fastq-loader

FASTQTEST_LOADER_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQTEST_LOADER_SRC))

$(TEST_BINDIR)/test-fastq-loader: $(FASTQTEST_LOADER_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

tfl:
	$(MAKE) -C $(OBJDIR) -f $(SRCDIR)/Makefile test-fastq-loader
	$(TEST_BINDIR)/test-fastq-loader

.PHONY: test-fastq-loader

#-------------------------------------------------------------------------------
# scripted tests
#
runtests: wb parse set_schema smalltests
	rm -v tmp.kfg

set_schema:
	echo "vdb/schema/paths = \"$(VDB_INCDIR)\"" > tmp.kfg

SMALLRUN = @ export NCBI_SETTINGS=/ ; export VDB_CONFIG=`pwd` ; \
	$(SRCDIR)/runtestcase.sh $(BINDIR) $(SRCDIR)
smalltests: $(TEST_TOOLS)
	-rm -rf $(SRCDIR)/actual
#   Small tests
#   Input:
#       Quality encoding: phred/logodds, ascii/decimal
#           1.1 phred 33
	$(SMALLRUN) 1.1 0 $(SRCDIR)/input/1.1.fastq --quality PHRED_33
#           1.2 phred 64
	$(SMALLRUN) 1.2 0 $(SRCDIR)/input/1.2.fastq --quality PHRED_64
#           1.3 phred 33, decimal qualities
	$(SMALLRUN) 1.3 3 $(SRCDIR)/input/1.3.fastq --quality PHRED_33
#           1.4 logodds 64
	$(SMALLRUN) 1.4 0 $(SRCDIR)/input/1.4.fastq --quality LOGODDS
#
#       Single input file
#           2.1 reads only, basespace
	$(SMALLRUN) 2.1 0 $(SRCDIR)/input/2.1.fastq --quality PHRED_33
#           2.1.1 reads only, colorspace
	$(SMALLRUN) 2.1.1 0 $(SRCDIR)/input/2.1.1.fastq --quality PHRED_33
#           2.2 qualities only
	@#-$(SMALLRUN) 2.2 0 $(SRCDIR)/input/2.2.fastq --quality PHRED_33
#           2.3 reads+qualities, qualities before reads
	@#-$(SMALLRUN) 2.3 0 $(SRCDIR)/input/2.3.fastq --quality PHRED_33
#           2.4 reads+qualities, reads before qualities
	@#-$(SMALLRUN) 2.4 0 $(SRCDIR)/input/2.4.fastq --quality PHRED_33
#           2.5 reads+qualities, paired up
	$(SMALLRUN) 2.5 0 $(SRCDIR)/input/2.5.fastq --quality PHRED_33
#           2.6 spot assembly
	$(SMALLRUN) 2.6 0 $(SRCDIR)/input/2.6.fastq --quality PHRED_33
#           2.7 spot assembly, read numbers not specified
	$(SMALLRUN) 2.7 0 $(SRCDIR)/input/2.7.fastq --quality PHRED_33
#           2.8 handling of N in reads, ALTREAD is a static column
#           TODO; investigate intermittent failure (FIXED_SPOT_LEN == 0, not 3)
	@#-$(SMALLRUN) 2.8 0 $(SRCDIR)/input/2.8.fastq --quality PHRED_33
#           2.8.1 handling of N in reads, ALTREAD is a physical column
	$(SMALLRUN) 2.8.1 0 $(SRCDIR)/input/2.8.1.fastq --quality PHRED_33
#           2.9 mismatching length of sequence and quality (qualities shorter)
	$(SMALLRUN) 2.9 3 $(SRCDIR)/input/2.9.fastq --quality PHRED_33
#           2.9.1 mismatching length of sequence and quality (qualities longer)
	$(SMALLRUN) 2.9.1 3 $(SRCDIR)/input/2.9.1.fastq --quality PHRED_33
#
#       Multiple files
#           3.1 reads+qualities together
	$(SMALLRUN) 3.1 0 $(SRCDIR)/input/3.1a.fastq $(SRCDIR)/input/3.1b.fastq --quality PHRED_33
#           3.2 qualities separately from reads, reads file comes first
	@#-$(SMALLRUN) 3.2 0 $(SRCDIR)/input/3.2a.fastq $(SRCDIR)/input/3.2b.fastq --quality PHRED_33
#           3.3 qualities separately from reads, qualities file comes first (reject?)
	@#-$(SMALLRUN) 3.3 0 $(SRCDIR)/input/3.3a.fastq $(SRCDIR)/input/3.3b.fastq --quality PHRED_33
#           3.4 default read number
#	$(SMALLRUN) 3.4 0 -r 1 $(SRCDIR)/input/3.4a.fastq -r 2 $(SRCDIR)/input/3.4b.fastq --quality PHRED_33
#
#   Command line options:
#           4.1 --tmpfs             temporary files created at the specified location
	@echo "running 4.1"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR);$(BINDIR)/latf-load \
	 $(SRCDIR)/input/4.fastq --tmpfs $(SRCDIR)/actual/ -v \
	 -o actual/4.1.obj --quality PHRED_33 \
	 | grep "Path for scratch files: $(SRCDIR)/actual/" >/dev/null
#           4.2 --qual-quant        quality values are quantized as specified
	$(SMALLRUN) 4.2 0 $(SRCDIR)/input/4.fastq --qual-quant 1:10,10:20,20:30,30:- --quality PHRED_33
#           4.3 --cache-size        handled correctly
	@echo "running 4.3"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR); \
	 $(BINDIR)/latf-load $(SRCDIR)/input/4.fastq --cache-size 10 -v \
     -o actual/4.1.obj --quality PHRED_33 \
     | grep "Cache size: 10M" >/dev/null
#           4.3.1 --cache-size      rejected if invalid
	$(SMALLRUN) 4.3.1 3 $(SRCDIR)/input/4.fastq --cache-size BIG --quality PHRED_33
#           4.4 --max-rec-count     stops at the specified record #
	$(SMALLRUN) 4.4 0 $(SRCDIR)/input/4.4.fastq --max-rec-count 3 --quality PHRED_33
#           4.5 --max-err-count     stops after the specified # of errors
	$(SMALLRUN) 4.5 3 $(SRCDIR)/input/4.5.fastq --max-err-count 2 --quality PHRED_33
#           4.5.1 --max-err-pct     fails if % of error records is too high
	$(SMALLRUN) 4.5.1 3 $(SRCDIR)/input/4.5.1.fastq --quality PHRED_33  --max-err-count 10 --max-err-pct 20
#           4.6 --platform          saves correct value in the PLATFORM column
	$(SMALLRUN) 4.6 0 $(SRCDIR)/input/4.fastq -p LS454 --quality PHRED_33
#           4.6.1 --platform        rejects invalid values
	$(SMALLRUN) 4.6.1 3 $(SRCDIR)/input/4.fastq -p SOMETHINGELSE --quality PHRED_33
#           4.7 input file missing
	$(SMALLRUN) 4.7 3 $(SRCDIR)/input/not_there --quality PHRED_33
#   Gzipped input
	$(SMALLRUN) 5.0 0 $(SRCDIR)/input/5.0.fastq.gz --quality PHRED_33
#   Misparsed quality
	$(SMALLRUN) 6.0 0 $(SRCDIR)/input/6.0.fastq --quality PHRED_33
#   PACBIO fastq
	$(SMALLRUN) 7.1 0 $(SRCDIR)/input/7.1.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.2 0 $(SRCDIR)/input/7.2.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.3 0 $(SRCDIR)/input/7.3.fastq --platform=PACBIO --quality PHRED_33
#   secondary read numbers other than 3
	$(SMALLRUN) 8.0 0 $(SRCDIR)/input/8.0.fastq --quality PHRED_33
#   reject inconsistent secondary read numbers
	$(SMALLRUN) 8.1 3 $(SRCDIR)/input/8.1.fastq --quality PHRED_33
#   newest Illumina tag line variation ("_" instead of " /")
	$(SMALLRUN) 9.0 0 $(SRCDIR)/input/9.0.fastq --quality PHRED_33
#   accepting ascii quality values up to 126
	$(SMALLRUN) 10.0 0 $(SRCDIR)/input/10.0.fastq --quality PHRED_33
    # 2-file fasta, tag line Run.Spot.Read
	$(SMALLRUN) 11.0 0 $(SRCDIR)/input/11.0.1.fasta $(SRCDIR)/input/11.0.2.fasta --quality PHRED_33
    # 2-file fastq, tag line Run.Spot.Read
	$(SMALLRUN) 11.1 0 $(SRCDIR)/input/11.1.1.fastq $(SRCDIR)/input/11.1.2.fastq --quality PHRED_33
    # Illumina, ignore barcodes
	$(SMALLRUN) 12.0 0 $(SRCDIR)/input/12.0.fastq --quality PHRED_33 --ignore-illumina-tags
    # Illumina, use barcodes as spotgroups
	$(SMALLRUN) 12.1 0 $(SRCDIR)/input/12.1.fastq --quality PHRED_33
    # Illumina, use barcodes as spotgroups, alternative format
	$(SMALLRUN) 12.2 0 $(SRCDIR)/input/12.2.fastq --quality PHRED_33
    # Consume our own dog food (13.0.fastq created by fastq-dump )
	$(SMALLRUN) 13.0 0 $(SRCDIR)/input/13.0.fastq --quality PHRED_33
    # Consume our own dog food (13.1.fastq created by fastq-dump -F )
	$(SMALLRUN) 13.1 0 $(SRCDIR)/input/13.1.fastq --quality PHRED_33
    # SRA-2932: 30 is the preferred value for qualities when reading FASTA
	$(SMALLRUN) 14.0 0 $(SRCDIR)/input/14.0.fasta $(SRCDIR)/input/14.0.fasta --quality PHRED_33
	rm -rf $(SRCDIR)/actual
    # VDB-3154: buffer insufficient
	$(SMALLRUN) 15.0 0 $(SRCDIR)/input/15.0.fastq --quality PHRED_33
    # VDB-3413: multi-line reads and qualities
	$(SMALLRUN) 16.0 0 $(SRCDIR)/input/16.0.fasta --quality PHRED_33 --platform=PACBIO
	$(SMALLRUN) 16.1 0 $(SRCDIR)/input/16.1.fastq --quality PHRED_33 --platform=PACBIO

onetest:
	rm -rf $(SRCDIR)/actual
	$(SMALLRUN) 16.1 0 $(SRCDIR)/input/16.1.fastq --quality PHRED_33 --platform=PACBIO

=== test/fuse/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

runtests:

TOP ?= $(abspath ../..)

MODULE = test/fuse

TEST_TOOLS =

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# remote-fuser-test
#
REMOTE_FUSER_TEST_SRC = \
	remote-fuser-test   \
	utils

REMOTE_FUSER_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(REMOTE_FUSER_TEST_SRC))
    
REMOTE_FUSER_TEST_LIB =   \
	-sncbi-vdb-static   \
	-skapp

$(TEST_BINDIR)/remote-fuser-test: $(REMOTE_FUSER_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(REMOTE_FUSER_TEST_LIB)

#-------------------------------------------------------------------------------
# slowtests: match output vs sra-pileup
#

ifeq (linux,$(BUILD_OS))
    ifneq (Ubuntu,$(OS_DISTRIBUTOR))
        ifeq (,$(NOT_VERY_SLOW))
slowtests: run-test

run-test: $(TEST_BINDIR)/remote-fuser-test
	@$(SRCDIR)/remote_fuser_test.sh standard 180 $(TARGDIR)/bin

        else
slowtests: no-test
no-test:
	@echo SKIPPING VERY SLOW remote-fuser-test
        endif
    else
slowtests:
    endif
else
slowtests:
endif

.PHONY: run-test

=== test/install/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/install

ALL_TARGS = \

include $(TOP)/build/Makefile.env

ROOTDIR = $(SRCDIR)/root

SUBMAKE = $(MAKE) --no-print-directory

ifeq (true,$(LINUX_ROOT))
    #settings for the fake root mode
    INSTALL_DIR = $(ROOTDIR)
    KONFIG_DIR = $(ROOTDIR)/etc/ncbi
    SUBMAKE += LINUX_ROOT=$(LINUX_ROOT) ROOT=$(INSTALL_DIR)
else
    INSTALL_DIR = $(SRCDIR)/install
    KONFIG_DIR = $(INSTALL_DIR)/bin/ncbi
endif

# Override installation location
INST_BINDIR = $(INSTALL_DIR)/bin

SUBMAKE += -C $(TOP) INST_BINDIR=$(INST_BINDIR)

#-------------------------------------------------------------------------------
# runtests
#

INSTALLED_FILES = \
	$(KONFIG_DIR)/certs.kfg                     \
	$(KONFIG_DIR)/default.kfg                   \
	$(KONFIG_DIR)/vdb-copy.kfg                  \


runtests: test-install

test-install: cleanup
	@ echo "installing to $(INSTALL_DIR)"
	@ #
	@ echo "1. clean install"
	@ #
	@ $(SUBMAKE) install
	@ for i in $(INSTALLED_FILES); do test -f "$$i" || ( echo "$$i is not found" >>$(INSTALL_DIR)/missing ); done
	@ ! test -f $(INSTALL_DIR)/missing || ! cat $(INSTALL_DIR)/missing
	@ #
	@ #
	@ echo "2. uninstall"
	@ #
	@ $(SUBMAKE) uninstall
	@ for i in $(INSTALLED_FILES); do ! test -f "$$i" || ( echo "$$i still exists" >>$(INSTALL_DIR)/exist ); done
	@ ! test -f $(INSTALL_DIR)/exist || ! cat $(INSTALL_DIR)/exist
	@ #
	@ #
	@ echo "3. re-install, preserving modified .kfg files"
	@ #
	@ # install
	@ $(SUBMAKE) install
	@ # modify .kfg files
	@ echo newcert  >$(KONFIG_DIR)/certs.kfg
	@ echo newdflt  >$(KONFIG_DIR)/default.kfg
	@ echo newcopy  >$(KONFIG_DIR)/vdb-copy.kfg
	@ echo newncbi  >$(KONFIG_DIR)/ncbi-vdb.kfg     # this should be renamed and never installed again
	@ # reinstall
	@ $(SUBMAKE) install
	@ # verify changed files have been saved
	@ ( grep newcert  $(KONFIG_DIR)/certs.kfg.orig       >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newdflt  $(KONFIG_DIR)/default.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/default.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newcopy  $(KONFIG_DIR)/vdb-copy.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig has unexpected content" && exit 1 )
	@ ( grep newncbi  $(KONFIG_DIR)/ncbi-vdb.kfg.orig    >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg.orig has unexpected content" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/ncbi-vdb.kfg  ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg exists" && exit 1 )  # gone ...
	@ # verify that further reinstall does not overwrite previously saved files if there is no change
	@ $(SUBMAKE) install
	@ # verify saved files are still there
	@ ( grep newcert  $(KONFIG_DIR)/certs.kfg.orig       >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newdflt  $(KONFIG_DIR)/default.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/default.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newcopy  $(KONFIG_DIR)/vdb-copy.kfg.orig     >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ( grep newncbi  $(KONFIG_DIR)/ncbi-vdb.kfg.orig    >/dev/null ) || ( echo "Error: $(KONFIG_DIR)/ncbi-vdb.kfg.orig has unexpected content after reinstallation" && exit 1 )
	@ ! test -f $(KONFIG_DIR)/ncbi-vdb.kfg          # ... and stays gone
	@ #
	@ #
	@ echo "4. install, discarding older versions of .kfg files"
	@ rm -f $(KONFIG_DIR)/*.orig
	@ $(SUBMAKE) install
	@ # replace .kfg files with older versions
	@ cp $(SRCDIR)/default.kfg.2.8.1 	$(KONFIG_DIR)/default.kfg
	@ cp $(SRCDIR)/certs.kfg.2.8.1 		$(KONFIG_DIR)/certs.kfg
	@ cp $(SRCDIR)/vdb-copy.kfg.2.8.1 	$(KONFIG_DIR)/vdb-copy.kfg
	@ # reinstall
	@ $(SUBMAKE) install
	@ # verify newer files are installed
	@ diff $(BINDIR)/ncbi/default.kfg 			$(KONFIG_DIR)/default.kfg
	@ diff $(BINDIR)/ncbi/certs.kfg 			$(KONFIG_DIR)/certs.kfg
	@ diff $(TOP)/tools/vdb-copy/vdb-copy.kfg 	$(KONFIG_DIR)/vdb-copy.kfg
	@ # verify no old files were saved
	@ ( ! test -f $(KONFIG_DIR)/default.kfg.orig ) 	|| ( echo "Error: $(KONFIG_DIR)/default.kfg.orig exists" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/certs.kfg.orig ) 	|| ( echo "Error: $(KONFIG_DIR)/certs.kfg.orig exists" && exit 1 )
	@ ( ! test -f $(KONFIG_DIR)/vdb-copy.kfg.orig ) || ( echo "Error: $(KONFIG_DIR)/vdb-copy.kfg.orig exists" && exit 1 )
	@ #
	@ #
ifeq (,$(LINUX_ROOT))
	#
	# Run the same tests in simulated root mode
	#
	@ $(MAKE) LINUX_ROOT=true
endif

cleanup:
	rm -rf $(INSTALL_DIR)
ifeq (true,$(LINUX_ROOT))
	# in root mode, recreate "system" directories
	mkdir -p $(ROOTDIR)/usr/include  $(ROOTDIR)/etc/profile.d
endif

.PHONY: install

=== test/kget/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/kget

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

.PHONY: $(TEST_TOOLS)

#-------------------------------------------------------------------------------
# runtests: 
#
runtests: download

download:
	export PATH=$(BINDIR):$$PATH; export VDB_CONFIG=`pwd` ; \
		NCBI_SETTINGS=/ python test_kget.py # expect rc = 0 

#-------------------------------------------------------------------------------
# slowtests: match output vs wget
#

slowtests: diff-vs-wget

ACCESSION = SRR072810
URL = http://sra-download.ncbi.nlm.nih.gov/srapub/$(ACCESSION)

clean:
	rm -f $(ACCESSION)*

diff-vs-wget: clean
	$(BINDIR)/kget --reliable -c ./$(ACCESSION).cachetee $(URL) $(ACCESSION).dat --progress
	wget --no-check-certificate $(URL)
	diff ./$(ACCESSION) ./$(ACCESSION).dat
	#diff $(ACCESSION).sra ./$(ACCESSION).cachetee
	rm -f $(ACCESSION)*


.PHONY:

=== test/prefetch/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests
TOP ?= $(abspath ../..)
include $(TOP)/build/Makefile.env

CWD = $(shell pwd)
PUBLIC=/repository/user/main/public
CGI=https://www.ncbi.nlm.nih.gov/Traces/names/names.fcgi
LARGE=fasp://aspera@demo.asperasoft.com:aspera-test-dir-large/100MB
SRA=https://sra-download.ncbi.nlm.nih.gov
SRAF=fasp://dbtest@sra-download.ncbi.nlm.nih.gov
KMER=$(SRA)/traces/nannot01/kmer/000/390/GCA_000390265.1_R
KMERF=$(SRAF):data/sracloud/traces/nannot01/kmer/000/390/GCA_000390265.1_R
REFSEQ=$(SRA)/traces/refseq/KC702174.1
REFSEQF=$(SRAF):data/sracloud/traces/refseq/KC702174.1
SRR=$(SRA)/traces/sra59/SRR/000052/SRR053325
SRRF=$(SRAF):data/sracloud/traces/sra59/SRR/000052/SRR053325
WGS=$(SRA)/traces/wgs03/WGS/AF/VF/AFVF01.1
WGSF=$(SRAF):data/sracloud/traces/wgs03/WGS/AF/VF/AFVF01.1

runtests: urls_and_accs out_dir_and_file s-option

################################################################################
urls_and_accs:
	@mkdir -p tmp tmp2
	@rm -fr tmp/* tmp2/*
	@echo 'foo = "bar"' > tmp/t.kfg

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki 2>/dev/null ; \
        then echo "prefetch URL-1 when there is no kfg should fail"; exit 1; \
	    fi

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch https://github.com/ncbi/ 2>/dev/null ; \
        then echo "prefetch URL-2 when there is no kfg should fail"; exit 1; \
	    fi

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if ping -c1 intranet > /dev/null ; then \
	       if $(BINDIR)/prefetch http://intranet/ 2>/dev/null ; \
	       then echo "prefetch URL-2 when there is no kfg should fail"; exit 1; \
	       fi ; \
	    fi

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if ping -c1 intranet > /dev/null ; then \
	     if $(BINDIR)/prefetch http://intranet/irb/support.shtml  2>/dev/null ; \
	     then echo "prefetch URL-2 when there is no kfg should fail"; exit 1; \
	     fi ; \
	    fi

	@echo '$(PUBLIC)/apps/file/volumes/flat = "files"' > tmp/t.kfg
	@echo '$(PUBLIC)/root = "$(CWD)/tmp"' >> tmp/t.kfg

	@if ls `pwd`/tmp2/support.shtml 2> /dev/null ; \
     then echo support.shtml found ; exit 1 ; fi
	@echo HTTP download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch http://intranet/irb/support.shtml > /dev/null ; fi
	@if ping -c1 intranet > /dev/null ; \
	 then ls `pwd`/tmp2/support.shtml > /dev/null ; fi
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	     $(BINDIR)/prefetch http://intranet/irb/support.shtml \
	        | grep "found local" > /dev/null ; fi
#	@echo

	@if ls `pwd`/tmp2/index.html 2> /dev/null ; \
     then echo index.shtml found ; exit 1; fi
	@echo HTTP download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch http://intranet/ > /dev/null ; fi
	@if ping -c1 intranet>/dev/null; then ls `pwd`/tmp2/index.html > /dev/null;fi
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch http://intranet/ | grep "found local" > /dev/null ; fi
	@rm -f tmp2/index.html
#	@echo

	@echo URL download when user repository is configured
	@if ls `pwd`/tmp2/wiki 2> /dev/null ; then echo wiki found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki > /dev/null
	@ls `pwd`/tmp2/wiki > /dev/null
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki \
	                              | grep "found local" > /dev/null
#	@echo

	@echo URL/ download when user repository is configured
	@if ls `pwd`/tmp2/index.html 2> /dev/null ; \
     then echo index.html found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ > /dev/null
	@ls `pwd`/tmp2/index.html > /dev/null
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/|grep "found local">/dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(SRR) 2> /dev/null ; \
        then echo "prefetch $(SRR) when there is no kfg should fail"; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/sra/volumes/sraFlat = "sra"' >> tmp/t.kfg
	@if ls `pwd`/tmp/sra/SRR053325.sra 2> /dev/null ; \
     then echo SRR053325.sra found ; exit 1; fi
	@echo SRR download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRR) > /dev/null
	@ls `pwd`/tmp/sra/SRR053325.sra > /dev/null
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRR) | grep "found local" > /dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(REFSEQ) 2> /dev/null ; \
        then echo "prefetch $(SRR) when there is no kfg should fail" ; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/refseq/volumes/refseq = "refseq"' >> tmp/t.kfg
	@echo REFSEQ download when user repository is configured
	@if ls `pwd`/tmp/refseq/KC702174.1 2> /dev/null ; \
     then echo KC702174.1 found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(REFSEQ) > /dev/null
	@ls `pwd`/tmp/refseq/KC702174.1 > /dev/null
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(REFSEQ) | grep "found local" > /dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(KMER) 2> /dev/null ; \
        then echo "prefetch $(KMER) when there is no kfg should fail"; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/nakmer/volumes/nakmerFlat = "nannot"' >> tmp/t.kfg
	@echo NANNOT download when user repository is configured
	@if ls `pwd`/tmp/nannot/GCA_000390265.1_R 2> /dev/null ; \
     then echo GCA_000390265.1_R found ; exit 1 ; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(KMER) > /dev/null
	@ls `pwd`/tmp/nannot/GCA_000390265.1_R > /dev/null
#	@echo

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(KMER) | grep "found local" > /dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(WGS) 2> /dev/null; \
        then echo "prefetch $(WGS) when there is no kfg should fail" ; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/wgs/volumes/wgsFlat = "wgs"' >> tmp/t.kfg
	@echo WGS download when user repository is configured
	@if ls `pwd`/tmp/wgs/AFVF01 2> /dev/null ; \
     then echo AFVF01 found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(WGS) > /dev/null
	@echo INCORRECT DOWNLOAD OF WGS SHOULD BE FIXED: VDB-3537
	@ls `pwd`/tmp/wgs/AFVF01 > /dev/null ;
	@echo

	@rm `pwd`/tmp/sra/SRR053325.sra
	@echo SRR FASP download when user repository is configured
	if ascp -h > /dev/null ; then \
	  if [ `hostname` != 'iebdev21' ] ; then \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRRF) > /dev/null ; \
	    ls `pwd`/tmp/sra/SRR053325.sra > /dev/null ; \
	  else echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD;\
	  fi \
	 else echo download of $(SRRF) when ascp is not found is disabled ; \
	 fi
#	@echo

	@rm `pwd`/tmp/refseq/KC702174.1
	@echo REFSEQ download when user repository is configured
	@if ascp -h > /dev/null ; then \
	  if [ `hostname` != 'iebdev21' ] ; then \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(REFSEQF) > /dev/null ; \
	    ls `pwd`/tmp/refseq/KC702174.1 > /dev/null ; \
	  else echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD;\
	  fi \
	 else echo download of $(REFSEQF) when ascp is not found is disabled ; \
	 fi
#	@echo

	@rm `pwd`/tmp/nannot/GCA_000390265.1_R
	@echo NANNOT FASP download when user repository is configured
	@if ascp -h > /dev/null ; then \
	  if [ `hostname` != 'iebdev21' ] ; then \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(KMERF) > /dev/null ; \
	      ls `pwd`/tmp/nannot/GCA_000390265.1_R > /dev/null ; \
	  else echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD;\
	  fi \
	 else echo download of $(KMERF) when ascp is not found is disabled ; \
	 fi
#	@echo

	@rm `pwd`/tmp/wgs/AFVF01
	@echo WGS download when user repository is configured
	@if ls `pwd`/tmp/wgs/AFVF01 2> /dev/null ; \
     then echo AFVF01 found ; exit 1; fi
	@if ascp -h > /dev/null ; then \
	  if [ `hostname` != 'iebdev21' ] ; then \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(WGSF) > /dev/null ; \
	    echo INCORRECT DOWNLOAD OF WGS SHOULD BE FIXED: VDB-3537 ; \
	    ls `pwd`/tmp/wgs/AFVF01 > /dev/null ; \
	  else echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD HOST; echo BAD;\
	  fi \
	 else echo download of $(WGSF) when ascp is not found is disabled ; \
	 fi
	@echo

	@rm -f `pwd`/tmp/sra/SRR053325.sra
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch SRR053325 2> /dev/null ; \
        then echo "prefetch SRR053325 when there is no kfg should fail" ; \
             exit 1; \
	    fi

	@echo 'repository/remote/main/CGI/resolver-cgi = "$(CGI)"' >> tmp/t.kfg
	@echo SRR accession download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch SRR053325 > /dev/null
	@ls `pwd`/tmp/sra/SRR053325.sra > /dev/null
#	@echo

	@echo prefetch run with refseqs
	@if ls `pwd`/tmp/sra/SRR619505.sra 2> /dev/null ; \
     then echo SRR619505 found ; exit 1; fi
	@if ls `pwd`/tmp/refseq/NC_000005.8 2> /dev/null ; \
     then echo NC_000005.8 found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch SRR619505 > /dev/null
	@ls `pwd`/tmp/sra/SRR619505.sra > /dev/null
	@ls `pwd`/tmp/refseq/NC_000005.8 > /dev/null

	@echo REFSEQ accession download
	@rm -f `pwd`/tmp/refseq/KC702174.1

=== test/qual-recalib-stat/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/qual-recalib-stat

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

runtests: check_exit_code

#-------------------------------------------------------------------------------
# scripted tests
#

check_exit_code:
	@ python $(TOP)/build/check-exit-code.py $(BINDIR)/qual-recalib-stat

.PHONY: $(TEST_TOOLS)

clean: stdclean

=== test/read-filter-redact/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)

include $(TOP)/build/Makefile.env

runtests: check_version

RUN=tmp-read-filter-redact-test-run
FLT=tmp-read-filter-redact-test-in

check_version: #/align-cache/CSRA_file
	# remove old test files
	@ if $(BINDIR)/vdb-unlock $(RUN) 2>/dev/null ; then echo ; fi
	@ rm -fr tmp-read-filter-redact-test-*


	# prepare sources
	@ echo 1 > $(FLT)
	@ $(BINDIR)/kar --extract ../align-cache/CSRA_file \
		--directory $(RUN)

	# make sure HISTORY meta does not exist
	@ if $(BINDIR)/kdbmeta tmp-read-filter-redact-test-run \
				-TSEQUENCE HISTORY 2>/dev/null; \
		then echo "error: HISTORY found in source metadata"; exit 1; fi

	# read-filter-redact
	@ $(BINDIR)/read-filter-redact -F$(FLT) $(RUN)

	# make sure HISTORY meta was created
	@ $(BINDIR)/kdbmeta tmp-read-filter-redact-test-run -TSEQUENCE HISTORY | \
		grep '^  <EVENT_1 build="' | grep '" run="' | \
		grep '" tool="read-filter-redact" vers="'

	# remove old test files
	@ $(BINDIR)/vdb-unlock $(RUN)
	@ rm -fr tmp-read-filter-redact-test-*

=== test/sra-pileup/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sra-pileup

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

runtests: check_exit_code

slowtests: fastq_dump_vs_sam_dump sam_dump_spotgroup_for_all

#-------------------------------------------------------------------------------
# scripted tests
#

check_exit_code:
	@ python $(TOP)/build/check-exit-code.py $(BINDIR)/sra-pileup


ACC = SRR3332402

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
fastq_dump_vs_sam_dump :
	@ python test_diff_fastq_dump_vs_sam_dump.py -a $(ACC) -f $(BINDIR)/fastq-dump -m $(BINDIR)/sam-dump

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
sam_dump_spotgroup_for_all :
	@ python test_all_sam_dump_has_spotgroup.py -a $(ACC) -m $(BINDIR)/sam-dump

    
.PHONY: $(TEST_TOOLS)

clean: stdclean

=== debian/changelog ===
sra-sdk (2.9.3+dfsg-1) unstable; urgency=medium

  * Team upload.

  * New upstream version.

 -- Steffen Moeller <moeller@debian.org>  Tue, 23 Oct 2018 15:12:22 +0200

=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               libngs-sdk-dev (>= 2.9.0),
               libncbi-vdb-dev (>= 2.9.1),
               libvdb-sqlite-dev,
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libxml2-dev,
               python
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/

Package: sra-toolkit
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config (>= 2.1)
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

=== debian/rules ===
#!/usr/bin/make -f

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

pkg := sra-toolkit

%:
	dh $@ --no-parallel

OUTDIR=$(CURDIR)/debian/tmp
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -f build/OUTDIR.linux

override_dh_update_autotools_config:
	echo "do nothing"

override_dh_auto_configure:
	# output dir will be checked so create it before
	mkdir -p debian/tmp/usr/lib
	ln -s /usr/lib/$(MULTIARCH) debian/tmp/usr/lib
	#
        # that's no standard configure script lacking support of default options
	#
	# --with-debug sets some options that require header files like compiler.h which
	# is internal to ncbi-vcb and not installed into the package - so this option
	# should not be used.
	./configure --build=$(MULTIARCH) --prefix=$(CURDIR)/debian/tmp/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make DEB_CFLAGS="$(CFLAGS)" DEB_LDFLAGS="$(LDFLAGS)"

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	for bin in debian/tmp/usr/bin/*[a-z] ; do \
	    mv debian/tmp/usr/bin/`readlink $$bin` $$bin ; \
	    mv debian/tmp/usr/bin/`readlink $$bin` $$bin ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# rename kget which conflicts with kget download manager (see #851219)
	mv debian/$(pkg)/usr/bin/kget debian/$(pkg)/usr/bin/vdb-get

override_dh_auto_test:
	dh_auto_test --no-parallel || true
	dh_auto_test --no-parallel

override_dh_prep:
	dh_prep -X debian/tmp
